#  Import the PyChips code - PYTHONPATH must be set to the PyChips installation src folder!
from PyChipsUser import *
import sys
import unittest

##################################################################################################
### Uncomment one of the following two lines to turn on verbose or very-verbose debug modes.   ###
### These debug modes allow you to see the packets being sent and received.                    ###
##################################################################################################
#chipsLog.setLevel(logging.DEBUG)    # Verbose logging (see packets being sent and received)

# Read in an address table by creating an AddressTable object (Note the forward slashes, not backslashes!)
#addrTable = AddressTable("addressTables/TTTEthVerTable.txt")
addrTable = AddressTable("vhdl2addrTable/addrTable.txt")
# Create a ChipsBus bus to talk to your board.
# These require an address table object, an IP address and a port number
myBoard = ChipsBusUdp(addrTable, "192.168.1.6", 50001) 
print hex(myBoard.read("FirmwareVersionID"))
#myBoard.write("TTSActionReg", 0x1000)

orbit_length = 3563;
trig_delay = 500;
orbit_count = 0;
trig_spacing = 100;
trig_per_orbit = 10;
repeat_period = 2;
backpressure = 0;
random_period = 0;
rule_no = 0;
latency = 0;
tts_mask = 0;
ttc_bcn = 1000;
allow_gap = 0;
front_porch = 250;
back_porch = 500;

myBoard.write("TTSControlReg", 0x0)

myBoard.blockWrite("TTSOrbitLength", [orbit_length, trig_delay, orbit_count, trig_spacing, trig_per_orbit, repeat_period])
myBoard.write("TTSRateSet", random_period)
myBoard.write("TTSSetBpDelay", latency)
myBoard.write("TTSBpSampleMask", tts_mask)
myBoard.write("TTSTtcBxNum", ttc_bcn)

myBoard.write("TTSControlReg", 0x3)
myBoard.write("TTSActionReg", 0x80)
myBoard.write("TTSActionReg", 0x01)
print hex(myBoard.read("TTSStatusReg"))
print hex(myBoard.read("TTSDataReg"))


# myBoard.write("TTSOrbitLength", 0x1FFF1F11) 
# print hex(myBoard.read("TTSOrbitLength"))
# myBoard.write("TTSTrigStart", 0x112)
# print hex(myBoard.read("TTSTrigStart"))
# print hex(myBoard.read("TTSOrbitLength"))


# print "Test"
# print "TTSTTCCmdPrescale"
# myBoard.write("TTSTtcCmdPrescale", 0x2)
# print hex(myBoard.read("TTSTtcCmdPrescale"))

# print "\n".join([hex(a) for a in myBoard.blockRead("TTSOrbitLength",19)[1:]])

# print "\nTEST2\n"
# print "TTSControlReg"
# myBoard.write("TTSControlReg", 0xAB)
# print hex(myBoard.read("TTSControlReg"))


# print "\n".join([hex(a) for a in myBoard.blockRead("TTSOrbitLength",20)[1:]])

# leds=0

# try:
#     leds = int(sys.argv[1], 16)
# except IndexError:
#     leds = 0

# myBoard.write("w_test",leds)
# print hex(myBoard.read("w_test"))






