import re

params = """orbit_length  <= get_bits( parm, 0, 12);    -- parm 0, 1
trig_start    <= get_bits( parm, 16, 12);   -- parm 2, 3
orbit_max     <= get_bits( parm, 32, 16);   -- parm 4, 5
l1a_spacing   <= get_bits( parm, 48, 12);   -- parm 6, 7
l1a_per_orbit <= get_bits( parm, 64, 8);    -- parm 8
repeat_period <= get_bits( parm, 72, 16);   -- parm 9, 10
fifo_byte     <= get_bits( parm, 88, 4);    -- parm 11
counter_byte  <= get_bits( parm, 96, 2);    -- parm 12
rate_set      <= get_bits( parm, 104, 16);  -- param 13, 14
rule_1 <= get_bits( parm, 16*8, 8);   -- param 16
rule_2 <= get_bits( parm, 17*8, 8);   -- param 17
rule_3 <= get_bits( parm, 18*8, 8);   -- param 18
rule_4 <= get_bits( parm, 19*8, 8);   -- param 19
clk_sel        <= get_bits( parm, 20*8, 2);  -- param 20
set_bp_delay   <= get_bits( parm, 21*8, 8);  -- param 21
bp_sample_mask <= get_bits( parm, 22*8, 8);  -- param 22
ttc_bx_num       <= get_bits( parm, 23*8, 12);  -- param 23, 24
ttc_cmd_prescale <= get_bits( parm, 25*8, 16);"""

print [param for param in params.split('\n')]
b = [re.search("(.*)\s+<=\s+get_bits\(\s+parm, ([0-9\*]+), ([0-9]+)", param) for param in params.split("\n")]

with file("TTSCTRL_addrTable.txt", 'w') as addrTable:
    for i, elem in enumerate(b):
        name = "TTS"+"".join([h.title() for h in elem.group(1).split("_")])
        addrTable.write("%-24s\t0x%.8x\t0xffffffff\t1\t1\n" % (name, 0x100+i))

with file("TTSCTRL_ipbus.vhdl.fragment", 'w') as ipb:
    for i, elem in enumerate(b):
        name = "TTS"+"".join([h.title() for h in elem.group(1).split("_")])
        ipb.write("-- %-24s\n" % name)
        ipb.write('when x"%.8x" => ttt_ipb_rw_reg(ipb_in, ipb_out, parm, %s, %s);\n' % (0x100+i, elem.group(2), elem.group(3)))
