----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:30:53 06/06/2012 
-- Design Name: 
-- Module Name:    bmc_encoder - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
-- use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity bmc_encoder is

  port (
    -- Inputs
    data     : in std_logic;  -- Serial data input. Shoud advace at 80Mhz
    clk160    : in std_logic;  -- The base clock rate is 2x the clock of the
                               -- data clock (2x80 => 160Mhz)
--    enable_n : in std_logic;            -- Low Active Enable
    rst_n : in std_logic;
    -- Outputs
    encoded_data : out std_logic  -- The output encoded data. Encoded clock is clk160/2 (clk)
    );

end bmc_encoder;

architecture Behavioral of bmc_encoder is
  signal data_buf  : std_logic := '0';
  signal clk_count : std_logic := '0';
begin
  -- Load data_buf into encoded_data if enable_n = '0'.

  encoded_data <= data_buf when rst_n = '1' else '0';

  -- Encode the incoming datastream, which should be clocked at clk160/2 which will be the
  -- data rate. This module requires a clock that is 2x the desired datarate clock.
  encode_data : process(clk160)
  begin
    if rising_edge(clk160) then
      if (rst_n = '0') then
        data_buf <= '0';
        clk_count <= '0';
      else
        -- toggle clk_count to figure out where the major beats (crochets) of the
        -- clock are, we only will toggle '1's on half beats (quavers).
        clk_count <= clk_count xor '1';
        if (clk_count = '1' and data = '1') then
          data_buf <= data_buf xor '1';
        elsif (clk_count = '0') then
          data_buf <= data_buf xor '1';
        end if;
      end if;
    end if;
  end process;  -- encode_data
end Behavioral;
